/*	1998		S.Honma (Rick)		*/

#include	<stdio.h>
#include	<string.h>
#include	"maish.h"

#define	ERR	(-1)


static int
qpdecode( ofp, ptr, fp, boundary )
FILE	*ofp;
unsigned char	*ptr;
FILE	*fp;
char	*boundary;
{
	int	nextline= 0;
	unsigned char	obuf[IOBUF];

	while( 1 ){
		int byte;

		if( !fgets( ptr, IOBUF, fp ) ){	/* EOF */
			return TRUE;
		}else if( !p_strmatch( ptr, boundary ) ){
			return TRUE;
		}

		if( strlen( ptr ) > 77 ){
			return FALSE;
		}

		byte= qp_line( obuf, ptr );
		if( byte == ERR ){
			return FALSE;
		}

		if( !nextline-- ){
			fputc( 'o', stderr );		/* i\ */
			nextline= 100;
		}
		if( byte ){
			fwrite( obuf, sizeof( unsigned char ), byte, ofp );
		}
	}
}


int
qp_decode( fp, ptr, boundary )
FILE	*fp;
unsigned char	*ptr;
char	*boundary;
{
	extern char	file_outname[], base[];
	char	fullname[STRBUF], *nameptr;
	FILE	*ofp;

	nameptr= p_strcpy( fullname, base );	/* WJfBNgw */
	p_strcpy( nameptr, file_outname );
	fputs( file_outname, stderr );

	if( !( ofp= fopen( fullname, "wb" ) ) ){
		fputs( "open error\n", stderr );
		return 0;
	}else{
		fputc( ' ', stderr );
		if( qpdecode( ofp, ptr, fp, boundary ) ){
			fputc( '\n', stderr );
		}else {
			fputs( " -- error\n", stderr );
		}
		fclose( ofp );
	}
	return	1;
}
