RUNS_HUMAN_VERSION	equ	3

	.cpu 68000

	.even
	.data
decmap:
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	.dc.b	16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31
	.dc.b	32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47
	.dc.b	48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63
	.dc.b	 0,-1,-1,-1,-1,-1, 6,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	.even

	.text
	.even
	.global	_num7str
_num7str:
	move.l	4(sp),a0	*str
	moveq.l	#0,d2		*perm
	moveq.l	#2,d1		*loop ct

octlp:
	move.b	(a0)+,d0
	cmp.b	#47,d0
	bls	bad
	cmp.b	#55,d0
	bhi	bad

	lsl.w	#3,d2		*perm <<= 3
	and.b	#7,d0
	add.b	d0,d2

	dbra	d1,octlp

	tst.b	(a0)
	bne	bad
	move.l	d2,d0
	rts

bad:
	moveq.l	#-1,d0
	rts

	.even

	.global	_DecodeLine
_DecodeLine:
	move.l	4(sp),a1	*str
	move.l	8(sp),a0	*ptr
	move.l	12(sp),d2	*uulength
	movem.l	d3/d4/d5/d6/d7/a3,-(sp)

	moveq.l	#0,d0
	move.b	(a0)+,d0

	lea.l	decmap(OPC),a2
	move.b	(a2,d0.w),d0	*byte
	bmi	err_ret

	movea.l	d0,a3
	moveq.l	#-1,d1
	cmp.l	d2,d1
	bne	notfirst
	moveq.l	#63,d1
	cmp.b	d0,d1
	bge	start
	bra	err_ret

notfirst:
	cmp.b	d0,d2
	blt	err_ret

start:
	addq.w	#2,d0		*byte
	divu	#3,d0
	moveq.l	#0,d5
	move.w	d0,d5		*len
	add.w	d5,d5
	add.w	d5,d5

	moveq.l	#0,d1		*code0
	moveq.l	#0,d2		*code1
	moveq.l	#0,d3		*code2
	moveq.l	#0,d4		*code3
	moveq.l	#0,d6		*sum
	moveq.l	#0,d7		*sumx
	bra	uud_ent

uud_lp:
	move.b	(a0)+,d1	*ptr[0]
	move.l	d1,d0		*ptr[0]
	move.b	(a2,d1.w),d1	*decmap[ptr[0]]
	bmi	err_ret

	move.b	(a0)+,d2	*ptr[1]
	add.w	d2,d0		*sumx
	move.b	(a2,d2.w),d2	*decmap[ptr[1]]
	bmi	err_ret

	move.b	(a0)+,d3	*ptr[2]
	add.w	d3,d0		*sumx
	move.b	(a2,d3.w),d3	*decmap[ptr[2]]
	bmi	err_ret

	move.b	(a0)+,d4	*ptr[3]
	add.w	d3,d0		*sumx
	move.b	(a2,d4.w),d4	*decmap[ptr[3]]
	bmi	err_ret

	add.l	d0,d7		*sumx

	add.b	d1,d1		*code0
	add.b	d1,d1
	move.l	d2,d0		*code1
	lsr.b	#4,d0
	add.b	d1,d0
	move.b	d0,(a1)+
	add.l	d0,d6		*sum

	lsl.b	#4,d2		*code1
	move.l	d3,d0		*code2
	lsr.b	#2,d0
	add.b	d2,d0
	move.b	d0,(a1)+
	add.l	d0,d6		*sum

	lsl.b	#6,d3		*code2
	add.b	d4,d3		*code3
	move.b	d3,(a1)+
	add.l	d3,d6		*sum

	subq.w	#4,d5		*len
uud_ent:
	tst.w	d5		*len
	bgt	uud_lp

	move.b	(a0),d0		*ptr
	cmp.b	#96,d0		*<= 'a'
	bls	sumchk
	cmp.b	#122,d0		*'z'<=
	bhi	sumchk
	addq.w	#1,a0		*ptr++
	bra	lastchk
sumchk:
	moveq.l	#0,d0
	move.b	(a0),d0		*ptr
	move.b	(a2,d0.w),d0	*decmap[*ptr]
	bmi	lastchk

	addq.w	#1,a0		*ptr++
	moveq.l	#63,d3
	and.b	d6,d3		*sum
	cmp.b	d3,d0
	beq	lastchk

	moveq.l	#63,d3
	and.b	d7,d3		*sumx
	cmp.b	d3,d0		*len
	bne	err_ret
lastchk:
	move.b	(a0),d0
	beq	normal_ret
	cmp.b	#10,d0		*LF
	beq	normal_ret
	cmp.b	#13,d0		*CR
	bne	err_ret

normal_ret:
	move.l	a3,d0		*byte
	bra	return

err_ret:
	moveq.l	#-1,d0

return:
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3
	rts

	.even
	.end
