/*	1993,1994	H.Ogasawara (COR.)	*/
/*	1998		S.Honma (Rick)		*/

#include	<stdio.h>
#include	"maish.h"

#define	ERR	(-1)


/*
static int
num7str( ptr )
unsigned char	*ptr;
{
	int i= 0, perm= 0;
	for( i= 0 ; i < 3 && *ptr >= '0' && *ptr <= '7' ; i++, ptr++ ){
		perm<<= 3;
		perm+= *ptr & 7;
	}
	if( !i || *ptr )
		return  -1;
	return  perm;
}
*/

int
uu_readhead( filename, ptr )
unsigned char	*filename;
unsigned char	*ptr;
{
	unsigned char	temp[STRBUF];

	ptr= get_word( temp, ptr );			/* begin Ƃ΂ */
	if( *ptr ){
		ptr= get_word( temp, ptr );		/* t@C */
		if( num7str( temp ) >= 0 && *ptr ){
			get_word( filename, ptr );	/* t@C */
			if( *filename ){
				return  TRUE;
			}
		}
	}

	return  FALSE;
}

/*
static int
DecodeLine( str, ptr, uulength )
unsigned char	*str, *ptr;
int	uulength;
{
	int	byte, len, sum= 0, sumx= 0;

	if( (byte= decmap[*ptr++]) < 0 ){
		return  ERR;
	}
	if( uulength == -1 ){
		if( byte > 63 ){
			return  ERR;
		}
	}else if( byte > uulength ){
		return  ERR;
	}

	for( len= (byte+2)/3*4 ; len > 0 ; len-= 4 ){
		int code0, code1, code2, code3;
		sumx+= *ptr +ptr[1] +ptr[2] +ptr[3];
		if( (code0= decmap[*ptr++]) < 0 ||
			(code1= decmap[*ptr++]) < 0 ||
			(code2= decmap[*ptr++]) < 0 ||
			(code3= decmap[*ptr++]) < 0 )
			return  ERR;
		sum+= *str++= (code0 <<2) + (code1 >>4);
		sum+= *str++= (code1 <<4) + (code2 >>2);
		sum+= *str++= (code2 <<6) + (code3    );
	}
	if( *ptr >= 'a' && *ptr <= 'z' ){
		ptr++;
	}else if( (len= decmap[*ptr]) >= 0 ){
		ptr++;
		if( (sum&0x3f) != len && (sumx&0x3f) != len ){
			return  ERR;
		}
	}
	if( *ptr == '\n' || *ptr == '\r' || !*ptr ){
		return  byte;
	}
	return  ERR;
}
*/

static int
uudecode( ofp, ptr, fp )
FILE	*ofp;
unsigned char	*ptr;
FILE	*fp;
{
	int	uulength= -1;
	int	nextline= 0;
	unsigned char	obuf[IOBUF];

	while( 1 ){
		int byte;

		if( !fgets( ptr, IOBUF, fp ) ){	/* EOF */
			return FALSE;
		}

		if( !*ptr || *ptr == '\n' ){	/* rŐ؂Ă? */
			return  FALSE;
		}

		byte= DecodeLine( obuf, ptr, uulength );
		if( byte == ERR ){
			return FALSE;
		}
		if( !byte ){					/* I */
			return	TRUE;
		}
		if( !nextline-- ){
			fputc( 'o', stderr );		/* i\ */
			nextline= 100;
		}
		fwrite( obuf, sizeof( char ), uulength= byte, ofp );
	}
}


int
uu_decode( fp, ptr )
FILE	*fp;
unsigned char	*ptr;
{
	extern char	file_outname[], base[];
	char	fullname[STRBUF], *nameptr;
	FILE	*ofp;

	nameptr= p_strcpy( fullname, base );	/* WJfBNgw */
	p_strcpy( nameptr, file_outname );
	fputs( file_outname, stderr );

	if( !( ofp= fopen( fullname, "wb" ) ) ){
		fputs( "open error\n", stderr );
		return 0;
	}else{
		fputc( ' ', stderr );
		if( uudecode( ofp, ptr, fp ) ){
			fputc( '\n', stderr );
		}else {
			fputs( " -- error\n", stderr );
		}
		fclose( ofp );
	}
	return	1;
}
